#include "StdAfx.h"
#include ".\basewindow.h"
#include <atltypes.h>


CBaseWindow::CBaseWindow(void)
{
}
CBaseWindow::~CBaseWindow(void)
{
}
BOOL CBaseWindow::Create(HWND hWndParent)
{
	BOOL bSuccess = FALSE;
	DWORD dwStyle = WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN;
	bSuccess = Create(hWndParent, CRect(0, 0, 0, 0), dwStyle);
	return bSuccess;
}
BOOL CBaseWindow::Create(HWND hWndParent,CRect rc, DWORD dwStyle, DWORD dwExStyle)
{
	BOOL bSuccess = FALSE;	
	HWND hWnd = CWindowImpl<CBaseWindow>::Create(hWndParent, rc, NULL, dwStyle, dwExStyle);
	bSuccess = ::IsWindow(hWnd);
	if (bSuccess)
	{		
		m_rootContainer.SetOwner(hWnd);
		this->SetWindow(hWnd);
		if (this->IsCenterWindow())
		{
			this->CenterWindow();
		}
		CRootContainer* rootContainer = GetRootContainer();
		if (rootContainer != NULL)
		{
			rootContainer->SetDataContext(this->GetDataContext());
		}
		this->OnCreate();
	}
	return bSuccess;
}
void CBaseWindow::OnFinalMessage(HWND hWnd)
{
	CWindow window = hWnd;
	if (FALSE == window.IsWindow())
	{
		delete this;
		return;
	}

	DWORD dwStyle = window.GetStyle();
	if (dwStyle & WS_POPUP)
		delete this;
}